LeetCode 322 Coin Change(フルバックパック)
You are given coins of different denominations and a total amount of money amount. Write a function to compute the fewest number of coins that you need to make up that amount. If that amount of money cannot be made up by any combination of the coins, return
Example 1: coins =
Example 2: coins =
Note: You may assume that you have an infinite number of each kind of coin.
タイトルリンク:https://leetcode.com/problems/coin-change/題目の分析:個数が無限なため、1つの完全なリュックサックの計数の問題で、dp[i]はiまで必要とする最低個数を表して、dpは無限大に初期化して、dp[0]=0
-1
. Example 1: coins =
[1, 2, 5]
, amount = 11
return 3
(11 = 5 + 5 + 1) Example 2: coins =
[2]
, amount = 3
return -1
. Note: You may assume that you have an infinite number of each kind of coin.
タイトルリンク:https://leetcode.com/problems/coin-change/題目の分析:個数が無限なため、1つの完全なリュックサックの計数の問題で、dp[i]はiまで必要とする最低個数を表して、dpは無限大に初期化して、dp[0]=0
public class Solution {
public int coinChange(int[] coins, int amount) {
int[] dp = new int[amount + 1];
Arrays.fill(dp, Integer.MAX_VALUE);
dp[0] = 0;
for(int i = 0; i < coins.length; i ++) {
for(int j = 0; j <= amount; j ++) {
int pre = j - coins[i];
if(pre >= 0 && dp[pre] < Integer.MAX_VALUE) {
dp[j] = Math.min(dp[j], dp[pre] + 1);
}
}
}
if(dp[amount] == Integer.MAX_VALUE) {
return -1;
}
return dp[amount];
}
}